Summary: Libsafe: Protecting Critical Elements of Stacks
Name: libsafe
Version: 1.3
Release: 9
Copyright: LGPL
Group: Applications/System
Source0: http://www.bell-labs.com/org/11356/src/libsafe-%{version}.tgz
Source1: libsafe.sh
Source2: libsafe.csh
Patch0: libsafe-makefile.patch
URL: http://www.bell-labs.com/org/11356/libsafe.html
BuildRoot: /var/tmp/libsafe-root
ExclusiveArch: i386

%description

The libsafe library protects a process against the exploitation of buffer
overflow vulnerabilities in process stacks. Libsafe works with any
existing pre-compiled executable and can be used transparently, even on a
system-wide basis. The method intercepts all calls to library functions
that are known to be vulnerable. A substitute version of the corresponding
function implements the original functionality, but in a manner that
ensures that any buffer overflows are contained within the current stack
frame. Libsafe has been shown to detect several known attacks and can
potentially prevent yet unknown attacks. Experiments indicate that the
performance overhead of libsafe is negligible.

%prep
%setup -q -n libsafe

%patch0 -p0

%build
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_lib} $RPM_BUILD_ROOT%{_mandir}/man8 $RPM_BUILD_ROOT%{_sysconfdir}/profile.d
install -m 0755 src/libsafe.so.%{version} $RPM_BUILD_ROOT/%{_lib}/
install -m 0644 doc/libsafe.8 $RPM_BUILD_ROOT%{_mandir}/man8
install -m 755 $RPM_SOURCE_DIR/libsafe.sh $RPM_BUILD_ROOT%{_sysconfdir}/profile.d
install -m 755 $RPM_SOURCE_DIR/libsafe.csh $RPM_BUILD_ROOT%{_sysconfdir}/profile.d

#create the liblink so that it can be owned by the package, so that
#RPM can handle packages which are built with libsafe.

pushd $RPM_BUILD_ROOT/lib
    ln -sf libsafe.so.%{version} libsafe.so.1
popd

touch $RPM_BUILD_ROOT%{_sysconfdir}/libsafe.notify

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%defattr(-,root,root)
%doc README COPYING ChangeLog INSTALL doc exploits
/%{_lib}/libsafe.so.%{version}
/%{_lib}/libsafe.so.1
%{_mandir}/*/*
%config(missingok,noreplace) %{_sysconfdir}/profile.d/libsafe.sh
%config(missingok,noreplace) %{_sysconfdir}/profile.d/libsafe.csh
%config(missingok,noreplace) %{_sysconfdir}/libsafe.notify

%changelog
* Mon Mar  5 2001 Tim Powers <timp@redhat.com>
- fixed bad group

* Mon Jan 22 2001 Tim Powers <timp@redhat.com>
- include the liblink libsafe.so.1 -> libsafe.so.1.3 in the package so
  that RPM can recognize proper provides (bug 24525)

* Mon Jul 24 2000 Prospector <prospector@redhat.com>
- rebuilt

* Mon Jul 10 2000 Tim Powers <timp@redhat.com>
- rebuilt

* Thu Jun 8 2000 Tim Powers <timp@redhat.com>
- fixed so that man pages arein the correct location
- used predefined RPM macros wherever possible

* Mon May 15 2000 Tim Powers <timp@redhat.com> 
- using this spec for 7.0 since it's a bit better than my orig for 6.2
- ditch redundant defines
- use %{_prefix} where possible
- quiet setup
- ExlusiveArch i386

* Tue Apr 25 2000 William Stearns <wstearns@pobox.com>
- install no longer tries to strip the man page or shell scripts.

* Fri Apr 21 2000 Jeremy Hansen <jeremy@xxedgexx.com>
- updated rpm.
- updated rpm again, got bugfix tar ball from Arash Baratloo <arash@research.bell-labs.com>

* Thu Apr 20 2000 Jeremy Hansen <jeremy@xxedgexx.com>
- initial package build.


